// Header to go here

/*
    SourceMod Anti-Cheat
	Copyright (C) 2011 Nicholas "psychonic" Hastings (nshastings@gmail.com)
    Copyright (C) 2007-2011 CodingDirect LLC

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//- Pre-processor Defines -//
#define PLUGIN_VERSION "0.0.3.8"
#define PLUGIN_BUILD 1

//#define NO_SOCKETS
#if defined NO_SOCKETS
	#undef PLUGIN_VERSION
	#define PLUGIN_VERSION "No-Socket Unofficial Build"
#endif

enum SMACGame {
	Game_Other,
	Game_CSS,
	Game_TF2,
	Game_DOD,
	Game_INS,
	Game_L4D,
	Game_L4D2,
	Game_HL2DM,
	Game_FOF,
	Game_GMOD,
};

//- SM Includes -//
#include <sourcemod>
#include <sdktools>
#undef REQUIRE_EXTENSIONS
#include <sdkhooks>
#define REQUIRE_EXTENSIONS

//- Natives -//
native SBBanPlayer(client, target, time, String:reason[]);
#define SOURCEBANS_AVAILABLE() (GetFeatureStatus(FeatureType_Native, "SBBanPlayer") == FeatureStatus_Available)

//- Global Variables -//
new bool:g_bConnected[MAXPLAYERS+1] = {false, ...};	// I use these instead of the natives because they are cheaper to call
new bool:g_bAuthorized[MAXPLAYERS+1] = {false, ...};	// when I need to check on a client's state.  Natives are very taxing on
new bool:g_bInGame[MAXPLAYERS+1] = {false, ...};	// system resources as compared to these. - Kigen
new bool:g_bIsFake[MAXPLAYERS+1] = {false, ...};
new bool:g_bMapStarted = false;
new bool:g_bSDKHooksLoaded = false;
new Handle:g_hValidateTimer[MAXPLAYERS+1] = {INVALID_HANDLE, ...};
new Handle:g_hDenyArray = INVALID_HANDLE;
new Handle:g_hCVarVersion = INVALID_HANDLE;
new Float:g_fTickRate = 66.6;
new SMACGame:g_Game = Game_Other; // Game identifier.

//- SMAC Modules -// Note: The ordering of these includes are imporant.
#include "smac/constants.sp"		// Constants - NEEDED FIRST
#include "smac/client.sp"			// Client Module
#include "smac/commands.sp"			// Commands Module
#include "smac/cvars.sp"			// CVar Module
#include "smac/eyetest.sp"			// Eye Test Module
#include "smac/wallhack.sp"			// Wallhack Module

#if !defined NO_SOCKETS
#include "smac/network.sp"			// Network Module
#endif

#include "smac/rcon.sp"				// RCON Module
#include "smac/css/antiflash.sp"	// CS:S Anti-Flash Module
#include "smac/css/antismoke.sp"	// CS:S Anti-Smoke Module
#include "smac/spinhack.sp"			// SpinHack Module
#include "smac/aimbot.sp"			// Aimbot Module


public Plugin:myinfo =
{
    name = "SourceMod Anti-Cheat",
    author = "psychonic, GoD-Tony, CodingDirect LLC", 
    description = "Open Source Anti-Cheat plugin for SourceMod", 
    version = PLUGIN_VERSION, 
    url = ""
};

//- Plugin Functions -//

// SourceMod 1.3 uses the new native AskPluginLoad2 so that APLRes can be used.
public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
#if !defined NO_SOCKETS
	Network_AskPluginLoad();
#endif
	MarkNativeAsOptional("SBBanPlayer");
	MarkNativeAsOptional("SDKHook");
	MarkNativeAsOptional("SDKUnhook");
	return APLRes_Success;
}

public OnPluginStart()
{
	LoadTranslations("smac.phrases");
	
	decl String:f_sGame[64];

	g_hDenyArray = CreateTrie();

//- Identify the game -//
	GetGameFolderName(f_sGame, sizeof(f_sGame));
	if ( StrEqual(f_sGame, "cstrike") )
		g_Game = Game_CSS;
	else if ( StrEqual(f_sGame, "dod") )
		g_Game = Game_DOD;
	else if ( StrEqual(f_sGame, "tf") )
		g_Game = Game_TF2;
	else if ( StrEqual(f_sGame, "insurgency") )
		g_Game = Game_INS;
	else if ( StrEqual(f_sGame, "left4dead") )
		g_Game = Game_L4D;
	else if ( StrEqual(f_sGame, "left4dead2") )
		g_Game = Game_L4D2;
	else if ( StrEqual(f_sGame, "hl2mp") )
		g_Game = Game_HL2DM;
	else if ( StrEqual(f_sGame, "fistful_of_frags") )
		g_Game = Game_FOF;
	else if ( StrEqual(f_sGame, "garrysmod") )
		g_Game = Game_GMOD;

	g_bSDKHooksLoaded = LibraryExists("sdkhooks");

//- Module Calls -//
	Client_OnPluginStart()
	Commands_OnPluginStart();
	CVars_OnPluginStart();
	Eyetest_OnPluginStart();
	Wallhack_OnPluginStart();
#if !defined NO_SOCKETS
	Network_OnPluginStart();
#endif
	RCON_OnPluginStart();
	AntiFlash_OnPluginStart();
	AntiSmoke_OnPluginStart();
	SpinHack_OnPluginStart();
	Aimbot_OnPluginStart();

	CreateTimer(14400.0, SMAC_ClearTimer, _, TIMER_REPEAT); // Clear the Deny Array every 4 hours.
	g_fTickRate = 1.0 / GetTickInterval(); // Cache the server's tickrate for calculations.

	AutoExecConfig(true, "smac");

	g_hCVarVersion = CreateConVar("smac_version", PLUGIN_VERSION, "SMAC version", FCVAR_PLUGIN|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	// "plugin" - Cause we are a plugin.  "notify" - So that we appear on server tracking sites.  "dontrecord" - So that we don't get saved to the auto cfg.
	SetConVarFlags(g_hCVarVersion, FCVAR_PLUGIN|FCVAR_NOTIFY|FCVAR_DONTRECORD); // Make sure "dontrecord" is there so that AutoExecConfig won't auto generate smac_version into the cfg file.
	SetConVarString(g_hCVarVersion, PLUGIN_VERSION);
	HookConVarChange(g_hCVarVersion, VersionChange);

	PrintToServer("%t", SMAC_LOADED);
}

public OnAllPluginsLoaded()
{
	decl String:f_sReason[256], String:f_sAuthID[64];

//- Module Calls -//
	Commands_OnAllPluginsLoaded();

//- Late load stuff -//
	for(new i=1;i<=MaxClients;i++)
	{
		if ( IsClientConnected(i) )
		{
			if ( !OnClientConnect(i, f_sReason, sizeof(f_sReason)) )
			{
				KickClient(i, "%s", f_sReason);
				continue;
			}
			else
				OnClientConnected(i);
			
			if ( IsClientAuthorized(i) && GetClientAuthString(i, f_sAuthID, sizeof(f_sAuthID)) )
				OnClientAuthorized(i, f_sAuthID);
			
			if ( IsClientInGame(i) )
				OnClientPutInServer(i);
		}
	}
}

public OnPluginEnd()
{
	RCON_OnPluginEnd();
}

public OnLibraryAdded(const String:name[])
{
	if (StrEqual(name, "sdkhooks"))
		g_bSDKHooksLoaded = true;
}

public OnLibraryRemoved(const String:name[])
{
	if (StrEqual(name, "sdkhooks"))
		g_bSDKHooksLoaded = false;
}

//- Map Functions -//

public OnMapStart()
{
	g_bMapStarted = true;
	CVars_CreateNewOrder();
	Client_OnMapStart();
	RCON_OnMap();
}

public OnMapEnd()
{
	g_bMapStarted = false;
	Client_OnMapEnd();
	RCON_OnMap();
	AntiSmoke_OnMapEnd();
}

//- Client Functions -//

public bool:OnClientConnect(client, String:rejectmsg[], size)
{
	if ( IsFakeClient(client) )
	{
		g_bIsFake[client] = true;
		return true;
	}

	return Client_OnClientConnect(client, rejectmsg, size);
}

public OnClientConnected(client)
{
	g_bConnected[client] = true;	
}

public OnClientAuthorized(client, const String:auth[])
{
	if ( g_bIsFake[client] )
		return;

	decl Handle:f_hTemp, String:f_sReason[256];

	if ( GetTrieString(g_hDenyArray, auth, f_sReason, sizeof(f_sReason)) )
	{
		KickClient(client, "%s", f_sReason);
		OnClientDisconnect(client);
		return;
	}

	g_bAuthorized[client] = true;

	if ( g_bInGame[client] )
		g_hPeriodicTimer[client] = CreateTimer(0.1, CVars_PeriodicTimer, client);

	f_hTemp = g_hValidateTimer[client];
	g_hValidateTimer[client] = INVALID_HANDLE;
	if ( f_hTemp != INVALID_HANDLE )
		CloseHandle(f_hTemp);
}

public OnClientPutInServer(client)
{
	g_bInGame[client] = true;
	
	Wallhack_OnClientPutInServer(client);
	
	if ( g_bIsFake[client] )
		return;

	if ( !g_bAuthorized[client] ) // Not authorized yet?!?
		g_hValidateTimer[client] = CreateTimer(10.0, SMAC_ValidateTimer, client);
	else	
		g_hPeriodicTimer[client] = CreateTimer(0.1, CVars_PeriodicTimer, client);
}

public OnClientDisconnect(client)
{
	// if ( IsFake aww, screw it. :P
	decl Handle:f_hTemp;

	g_bConnected[client] = false;
	g_bAuthorized[client] = false;
	g_bInGame[client] = false;
	g_bShouldProcess[client] = false;
	g_bHooked[client] = false;
	
	f_hTemp = g_hValidateTimer[client];
	g_hValidateTimer[client] = INVALID_HANDLE;
	if ( f_hTemp != INVALID_HANDLE )
		CloseHandle(f_hTemp);

	CVars_OnClientDisconnect(client);
#if !defined NO_SOCKETS
	Network_OnClientDisconnect(client);
#endif
	AntiFlash_OnClientDisconnect(client);
	AntiSmoke_OnClientDisconnect(client);
	SpinHack_OnClientDisconnect(client);
	Aimbot_OnClientDisconnect(client);
}

public OnClientDisconnect_Post(client)
{
	g_bIsFake[client] = false;
	
	Eyetest_OnClientDisconnect_Post(client);
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	SpinHack_OnPlayerRunCmd(client, buttons, angles);
	Aimbot_OnPlayerRunCmd(client, angles);
	Eyetest_OnPlayerRunCmd(client, angles);
	Wallhack_OnPlayerRunCmd(client, angles);

	return Plugin_Continue;
}

//- Global Private Functions -//

SMAC_Log(const String:format[], any:...)
{
	decl String:f_sBuffer[256], String:f_sPath[256], String:f_sDateTime[16];
	VFormat(f_sBuffer, sizeof(f_sBuffer), format, 2);
	FormatTime(f_sDateTime, sizeof(f_sDateTime), "%Y%m%d");
	BuildPath(Path_SM, f_sPath, sizeof(f_sPath), "logs/SMAC_%s.log", f_sDateTime);
	LogToFileEx(f_sPath, "%s", f_sBuffer);
}

bool:IsVectorNull(Float:vec[3])
{
	if (vec[0] == 0.0 && vec[1] == 0.0 && vec[2] == 0.0)
		return true;
	
	return false;
}

//- Timers -//

public Action:SMAC_ValidateTimer(Handle:timer, any:client)
{
	g_hValidateTimer[client] = INVALID_HANDLE;

	if ( !g_bInGame[client] || g_bAuthorized[client] )
		return Plugin_Stop;

	KickClient(client, "%t", SMAC_FAILEDAUTH);
	
	return Plugin_Stop;
}

public Action:SMAC_ClearTimer(Handle:timer, any:nothing)
{
	ClearTrie(g_hDenyArray);
}

//- ConVar Hook -//

public VersionChange(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if ( !StrEqual(newValue, PLUGIN_VERSION) )
		SetConVarString(g_hCVarVersion, PLUGIN_VERSION);
}

SMAC_Ban(client, time, const String:sKickPhrase[]="", const String:format[], any:...)
{
	decl String:f_sBuffer[256];
	VFormat(f_sBuffer, sizeof(f_sBuffer), format, 5);
	if ( SOURCEBANS_AVAILABLE() )
	{
		SBBanPlayer(0, client, time, f_sBuffer);
	}
	else if (sKickPhrase[0] != '\0')
	{
		decl String:sKickReason[256];
		Format(sKickReason, sizeof(sKickReason), "%T", sKickPhrase, client);
		BanClient(client, time, BANFLAG_AUTO, f_sBuffer, sKickReason, "SMAC");
	}
	else
	{
		BanClient(client, time, BANFLAG_AUTO, f_sBuffer, f_sBuffer, "SMAC");
	}
	OnClientDisconnect(client); // Bashats!
}

// From SourceMod's PrintToChatAll stock
SMAC_PrintToChatAdmins(const String:format[], any:...)
{
	decl String:buffer[192];
	
	for (new i = 1; i <= MaxClients; i++)
	{
		if (CheckCommandAccess(i, "smac_admin_notices", ADMFLAG_GENERIC, true))
		{
			SetGlobalTransTarget(i);
			VFormat(buffer, sizeof(buffer), format, 2);
			PrintToChat(i, "%s", buffer);
		}
	}
}

//- End of File -//
